:: targetip can be get by right clicking launched node and clicking "Show Node Info"
rem set targetip=xxxxxxxx.wall2.ilabt.iminds.be
set RSYNCUSER=alexs

:: Your Cygwin installation with rsync and openssl installation.
:: https://cygwin.com/install.html
set RSYNC=xxxxxxxx/Apps/Cygwin/bin/rsync.exe 
set RSYNCSSH=xxxxxxxx/Apps/Cygwin/bin/ssh.exe
set RSYNCSSHCMD=%RSYNCSSH% -o ServerAliveInterval=60

set SHAREDFOLDER=/groups/wall2-ilabt-iminds-be/soi-twin/vhdImages
:: set NODEFOLDER=/tmp/vhdImages
set NODEFOLDER=/groups/wall2-ilabt-iminds-be/soi-twin/nodes/%targetip%/vhdImages

set VHDLOCATION=xxxxxxxx/shark3dServerImage.vhd
set VHDNAME=shark3dServerImage.vhd
:: Virtual Box Extension pack needed for Remote Desktop in VM
:: https://www.virtualbox.org/wiki/Downloads download same version like VirtualBox
set VBOXEXTENSIONLOCATION=xxxxxxxx/Oracle_VM_VirtualBox_Extension_Pack-6.0.4.vbox-extpack
set VBOXEXTENSIONNAME=Oracle_VM_VirtualBox_Extension_Pack-6.0.4.vbox-extpack

:: Copys Fed4Fire certificate and removes password
:: Your fed4fire ssh public key and password can be found in AppData/Roaming/jFed/login-certs/ or 
:: can be downloaded from https://authority.ilabt.iminds.be/getcert.php .
rem set FED4FIREKEYFILE=xxxxxxxx
rem set FED4FIREKEYPASSWORD=xxxxxxxx
set WORKINGFOLDER=xxxxxxxx
set RSYNCSSHPUBLICKEY=%WORKINGFOLDER%\alexsMindsSSHpublic.pem

:: #################################################################################################################################################

:: Find gatewayip via of FED4Fire ssh shell
:: Before launching the batch you need to open a ssh shell in jFed Experinmenter Toolkit by rightclicking the
:: launched node.
:: ipv4:
:: for /f "tokens=4 delims=: " %%i in ('netstat -an ^| find "ESTABLISHED" ^| find ":22"') do set gatewayip=%%i
:: ipv6:
for /f "tokens=4 delims=[]" %%i in ('netstat -an ^| find "ESTABLISHED" ^| find ":22"') do set gatewayip=[%%i]

:: Skip setup and only launch VM.
set SKIPCOPY=1
set SKIPINSTALL=0

copy /Y "%FED4FIREKEYFILE%" "%RSYNCSSHPUBLICKEY%"
if errorlevel 1 goto :error
ssh-keygen -p -P "%FED4FIREKEYPASSWORD%" -N "" -f %RSYNCSSHPUBLICKEY%
if errorlevel 1 goto :error

:: Opens ssh tunnel.
start "Tunnel b2c1ef93-aa2f-4154-90a2-02a943de8e6e" /min plink -l %RSYNCUSER% -L 22:%targetip%:22 %gatewayip%
if errorlevel 1 goto :error
plink -l %RSYNCUSER% localhost sudo su -c 'echo "Tunnel Test"'
if errorlevel 1 goto :error

if "%SKIPCOPY%"=="1" goto :installvirtualbox
:: Copy VHD file.

plink -l %RSYNCUSER% localhost sudo su -c 'mkdir -p %SHAREDFOLDER%'
::if errorlevel 1 goto :error
plink -l %RSYNCUSER% localhost sudo su -c 'chmod agu+rw %SHAREDFOLDER%'
::if errorlevel 1 goto :error

plink -l %RSYNCUSER% localhost sudo su -c 'mkdir -p %NODEDFOLDER%'
::if errorlevel 1 goto :error
plink -l %RSYNCUSER% localhost sudo su -c 'chmod agu+rw %NODEDFOLDER%'
::if errorlevel 1 goto :error

set /a rsyncidx=0
:rsyncrepeat
echo ********** %date% %time%
set /a rsyncidx=rsyncidx+1
echo rsyncidx=%rsyncidx%
%RSYNC% -v --progress --partial-dir=.rsync-partial -e "%RSYNCSSHCMD% -l %RSYNCUSER% -i %RSYNCSSHPUBLICKEY%" /cygdrive/c%VHDLOCATION% %RSYNCUSER%@localhost:%SHAREDFOLDER%
if not errorlevel 1 goto :copyvirtualboxextension
if %rsyncidx% lss 10 goto :rsyncrepeat
goto :error

:copyvirtualboxextension
set /a rsyncidx=0
:rsyncrepeat
echo ********** %date% %time%
set /a rsyncidx=rsyncidx+1
echo rsyncidx=%rsyncidx%
%RSYNC% -v --progress --partial-dir=.rsync-partial -e "%RSYNCSSHCMD% -l %RSYNCUSER% -i %RSYNCSSHPUBLICKEY%" /cygdrive/c%VBOXEXTENSIONLOCATION% %RSYNCUSER%@localhost:%SHAREDFOLDER%
if not errorlevel 1 goto :installvirtualbox
if %rsyncidx% lss 10 goto :rsyncrepeat
if errorlevel 1 goto :error

plink -l %RSYNCUSER% localhost sudo su -c 'echo "deb https://download.virtualbox.org/virtualbox/debian xenial contrib" ^>^> /etc/apt/sources.list'
%RSYNC% -v --progress --partial-dir=.rsync-partial -e "%RSYNCSSHCMD% -l %RSYNCUSER% -i %RSYNCSSHPUBLICKEY%" /cygdrive/c%VBOXEXTENSIONLOCATION% %RSYNCUSER%@localhost:%SHAREDFOLDER%
if errorlevel 1 goto :error

plink -l %RSYNCUSER% localhost sudo su -c 'VBoxManage extpack install --replace "%SHAREDFOLDER%/%VBOXEXTENSIONNAME%" --accept-license=56be48f923303c8cababb0bb4c478284b688ed23f16d775d729b89a2e8e5f9eb'
if errorlevel 1 goto :error

:installvirtualbox
if "%SKIPINSTALL%"=="1" goto :launchvm
plink -l %RSYNCUSER% localhost sudo su -c 'echo "deb https://download.virtualbox.org/virtualbox/debian xenial contrib" ^>^> /etc/apt/sources.list'
if errorlevel 1 goto :error
plink -l %RSYNCUSER% localhost sudo su -c 'cat /etc/apt/sources.list'
if errorlevel 1 goto :error
plink -l %RSYNCUSER% localhost sudo su -c 'wget -O - -q https://www.wall2.ilabt.iminds.be/enable-nat.sh ^| sudo bash'
if errorlevel 1 goto :error
plink -l %RSYNCUSER% localhost sudo su -c 'wget -q https://www.virtualbox.org/download/oracle_vbox_2016.asc -O- ^| sudo apt-key add -'
if errorlevel 1 goto :error
plink -l %RSYNCUSER% localhost sudo su -c 'wget -q https://www.virtualbox.org/download/oracle_vbox.asc -O- ^| sudo apt-key add -'
if errorlevel 1 goto :error
plink -l %RSYNCUSER% localhost sudo su -c 'apt-get update'
if errorlevel 1 goto :error
plink -l %RSYNCUSER% localhost sudo su -c 'apt-get -q -V -y install virtualbox-6.0'
if errorlevel 1 goto :error

plink -l %RSYNCUSER% localhost sudo su -c 'VBoxManage controlvm "Shark3DVM" poweroff --type headless'
:: Don't check for error.
plink -l %RSYNCUSER% localhost sudo su -c 'VBoxManage unregistervm Shark3DVM'
:: Don't check for error.
plink -l %RSYNCUSER% localhost sudo su -c 'rm -rf /root/VirtualBox\ VMs/Shark3DVM'
:: Don't check for error.

:: https://devminz.github.io/posts/devops/virtualbox-cli-vm-bridged-networking/
::plink -l %RSYNCUSER% localhost sudo su -c 'brctl addbr vmtestbr1'
::plink -l %RSYNCUSER% localhost sudo su -c 'ifconfig  vmtestbr1 192.168.222.1  netmask 255.255.255.0 up'

:: https://www.perkin.org.uk/posts/create-virtualbox-vm-from-the-command-line.html
plink -l %RSYNCUSER% localhost sudo su -c 'VBoxManage createvm --name Shark3DVM --ostype Windows2012_64 --register'
if errorlevel 1 goto :error
::plink -l %RSYNCUSER% localhost sudo su -c 'VBoxManage modifyvm Shark3DVM --memory 10000 --cpus 5 --vrde on --natpf1 test,tcp,,33348,,33348'
::plink -l %RSYNCUSER% localhost sudo su -c 'VBoxManage modifyvm Shark3DVM --memory 10000 --cpus 5 --vrde on --nic1 natnetwork --bridgeadapter1 vmtestbr1'
::plink -l %RSYNCUSER% localhost sudo su -c 'VBoxManage modifyvm Shark3DVM --memory 10000 --cpus 5 --vrde on --nic1 natnetwork'
plink -l %RSYNCUSER% localhost sudo su -c 'VBoxManage modifyvm Shark3DVM --memory 10000 --cpus 5 --vrde on --largepages on --nested-hw-virt on --natpf1 "guestssh,tcp,,33348,,33348" --chipset ich9 --pciattach 3:00.0@01:05.0 --pciattach 3:00.1@01:05.1'
if errorlevel 1 goto :error
plink -l %RSYNCUSER% localhost sudo su -c 'VBoxManage storagectl Shark3DVM --name "SATA" --add sata --bootable on --controller IntelAHCI'
if errorlevel 1 goto :error
plink -l %RSYNCUSER% localhost sudo su -c 'VBoxManage storageattach Shark3DVM --storagectl "SATA" --port 0 --device 0 --type hdd --medium %SHAREDFOLDER%/%VHDNAME%'
if errorlevel 1 goto :error

:: Port forwarding:
::plink -l %RSYNCUSER% localhost sudo su -c 'VBoxManage natnetwork modify --netname natnet1 --port-forward-6 "shark3dsap:tcp:[]:33348:[10.0.2.15]:33348"'
::if errorlevel 1 goto :error

:: GPU passthrough
:: https://www.server-world.info/en/note?os=Ubuntu_18.04&p=kvm&f=11
:: https://www.virtualbox.org/manual/ch09.html#pcipassthrough
:: https://www.oracle.com/webfolder/technetwork/de/community/dbadmin/tipps/ovm_pcipassthrough/index.html

:: You can connect to the remote desktop by connecting to 127.0.0.1:3389 with your client
:launchvm
start "Tunnel 83d44a61-de59-4ca4-a5de-2d2742954f00" /min plink -l %RSYNCUSER% -L 3389:%targetip%:3389 %gatewayip%
plink -l %RSYNCUSER% localhost sudo su -c 'VBoxManage startvm "Shark3DVM" --type headless'
rem plink plink -l %RSYNCUSER% localhost sudo su -c 'VBoxManage controlvm "Shark3DVM" poweroff --type headless'

call :finish
echo !!!! Success !!!!
exit /b 1

:error
call :finish
echo !!!! Error !!!!
exit /b 0

:finish
:: Close ssh tunnel
taskkill /f /fi "windowtitle eq Tunnel b2c1ef93-aa2f-4154-90a2-02a943de8e6e"
goto :eof
